#include "base.h"
#include "tree.h"
#include "escape.h"
#include "proc.h"
#include "gui.h"


static char *help_txt[] =
{
    "[123456]...sort by corresponding column",
    "r...........refresh",
    "k...........kill processes",
    "t...........toggle kill signal",
    "q...........quit",
    "0.........tree view",
    "s...........search",
    "LEFT........back one screen",
    "e...........expand/collapse all",
    "ENTER.......expand/collapse",
    "c...........issue command",
    "a...........select all",
    "C...........clear all selections",
    "R...........revert selections",
    "m...........monitor selected processes",
    "TAB.........cancel",
    "f...........find",
    "g...........find again",
    NULL
};


int getchoice(killer_t * chow)
{
    static int selected_row = 0;
    static unsigned int selected = 0;
    static int key = KEY_F(3);
    static int tag = 0;
    static int sig = 0;
    #define NRSIGS 6
    int siglist[NRSIGS] = {1, 9, 6, 3, 2, 15};
    char *signame[NRSIGS] = { "SIGHUP ", "SIGKILL", "SIGABRT", 
			 "SIGQUIT", "SIGINT ", "SIGTERM" };
    int tmp = 0;
    char sigstr[8];
    /*static int t_view = 0;*/
    procinfo_t *list;
    static int e_view = 1;

    int i;

    int count;
    char input[BOX_WIDTH - 5];

    int pos;

    killer_t *sub;

    /* printf("in get choice\n"); */

    strcpy(sigstr, signame[sig]);

    if (key == KEY_F(1) || key == KEY_F(2) || key == KEY_F(3) 
        || key == KEY_F(4) || key == KEY_F(5) || key == KEY_F(6) 
	|| key == 'k' || key == 'r' || key == '\n' || key == 'e' 
	|| key == 's' || key == KEY_LEFT || key == 'c' || key == ' ' 
	|| key == KEY_F(7) || key == 'a' || key == 'C' || key == 'm'
	|| key == '1' || key == '2' || key == '3' || key == '4' || key == '5'
	|| key == '6' || key == '7') {
	
      if (key == 'k' || key == 'r' || key == '\n' || key == 'e' 
	  || key == 's' || key == KEY_LEFT || key == 'c' || key == ' ' 
	  || key == 'a' || key == 'C' || key == 'm') {
	    tag = -1;
	    /*if (e_view) {
		for (i = 0; i < chow->count; i++) {
		    chow->pidlist[i].expand = 1;
		}
	    }*/
	} else
	    tag = key;


	if (e_view) {
	    for (i = 0; i < chow->count; i++) {
		chow->pidlist[i].expand = 1;
	    }
	}
	shell_sort(chow->pidlist, tag, chow->count);
	chow->t_count = 0;

	make_tree(chow);
	graph_branch(chow->ptree, chow, 0);

	draw_strings(chow->trunk, chow->t_count);

	free_branch(chow->ptree);
    }
#if !DEBUG
    draw_top(tag);
    attrset(0);
    mvprintw(0, COLS - 8, "%s", sigstr);
    refresh();
#endif
    /*  printf("chk point\n"); */
    if (key == KEY_F(10) || key == '0') {
	/*  clear_all_screen(); */
	for (i = 0; i <= MAX_ROW; i++) {
	    row_clear(i);
	}
	if (t_view == 0) {
	    /*  selected_row = selected = 0; */
	    t_view = 1;
	} else
	    t_view = 0;
    }
    /*  mvprintw(0, 0, "%s", "chkpoint2"); */
    /*      printf("chk point"); */
    if (t_view) {
	list = chow->trunk;
	count = chow->t_count;
	/* clear_all_screen(); */
    } else {
	list = chow->pidlist;
	count = chow->count;
    }

    if (count > 0) {
	while (selected > count || selected_row > count - 1) {
	    selected--;
	    selected_row--;
	}
    }
    
    if (key != 'h') {
	/*  if(!t_view) */
	/*   mvprintw(0, 0, "%s", "draw menu"); */
#if !DEBUG
	draw_menu(chow, selected_row, selected, count, t_view);
#endif
	/*  mvprintw(0, 0, "%i", list[selected].is_selected); */

	/*  else */
	/*      draw_menu(chow, selected_row, selected, chow->t_count, t_view); */
	/*  else */
	/*      return -5; */
    } else
	help_screen();

    if (key != 'h') {
/*  #if DEBUG */
/*      printf("waiting for key...\n"); */
/*  #endif */
	fflush(stdin);
	key = getch();

	if (key == KEY_UP) {
	    move_up(1, &selected_row, &selected);
	}
	if (key == KEY_DOWN) {

	    move_down(1, &selected_row, &selected, count);
	    /*  else */
	    /*            move_down(1, &selected_row, &selected, ); */
	}
	if (key == KEY_NPAGE) {
	    /*  if(!t_view) */
	    move_down(MAX_ROW, &selected_row, &selected, count);
	    /*  else */
	    /*            move_down(MAX_ROW, &selected_row, &selected, t_row); */
	}
	if (key == KEY_PPAGE) {
	    move_up(MAX_ROW, &selected_row, &selected);
	}
	/*  mvprintw(0, 0, "%i",  list[selected].proc->pid); */
	if (key == 'k' && count) {

	    /*  if(killer.uid == list[selected].uid || killer.uid == 0) { */

	    murder(selected, list, count, siglist[sig]);
	    /*  selected_row = selected = 0;  */
	    /*  } */
	    if (chow->monitoring)
		tmp = -7;
	    else
		tmp = -2;
	}
	if (key == '\n') {
	    if (t_view) {
		pos = pid_pos(list[selected].proc->pid, chow->pidlist, chow->count);
		chow->pidlist[pos].expand = (chow->pidlist[pos].expand + 1) % 2;
		e_view = 0;
		/*  selected_row = selected = 0; */
	    }
	    tmp = 0;
	    /*  else */
	    /*            key = 'r'; */
	}
	if (key == 'e') {
	    for (i = 0; i <= MAX_ROW; i++) {
		row_clear(i);
	    }
	    if (t_view) {
		if (!e_view) {
		    for (i = 0; i < chow->count; i++) {
			chow->pidlist[i].expand = 1;
		    }
		    e_view = 1;
		} else
		    for (i = 0; i < chow->count; i++) {
			chow->pidlist[i].expand = 0;
			e_view = 0;
		    }
	    }
	    clear_all_screen();
	    tmp = 0;
	}
	if (key == 's') {
	    if (chow->count) {
		input[0] = '\0';
		input_dlg(input, "search for:");
		if (input[0] != '\0') {
		    search(chow, input);
		    tmp = -4;
		} else
		    tmp = 0;
	    } else
		tmp = 0;
	}

	if (key == 'f') {
	    if (chow->count) {
		input[0] = '\0';
		input_dlg(input, "find:");
		if (input[0] != '\0') {
		    find(chow, input, &selected, &selected_row, t_view);
		}
	    }
	    tmp = 0;
	}


	if (key == 'g') {
	    if (chow->count) {
		if (input[0] != '\0') {
		    find(chow, input, &selected, &selected_row, t_view);
		}
	    }
	    tmp = 0;
	}

	
	if (key == 'c') {
	    if (chow->count) {
		sprintf(input, "%i", list[selected].proc->pid);
		input_dlg(input, "command:");
		if (input[0] != '\0') {
		    system(input);
		    sleep(1);
		    tmp = -2;
		} else
		    tmp = 0;
	    } else
		tmp = 0;
	}
	if (key == ' ') {
	    if (count) {
		sub = chow;
		while (sub) {
		    pos = pid_pos(list[selected].proc->pid, sub->pidlist, sub->count);
		    sub->pidlist[pos].is_selected = (sub->pidlist[pos].is_selected + 1) % 2;
		    sub = sub->mother;
		}
	    }
	    move_down(1, &selected_row, &selected, count);
	    tmp = 0;
	}
	if (key == 'a') {
	    for (i = 0; i < count; i++) {
		sub = chow;
		while (sub) {
		    pos = pid_pos(list[i].proc->pid, sub->pidlist, sub->count);
		    sub->pidlist[pos].is_selected = 1;
		    sub = sub->mother;
		}
	    }
	    tmp = 0;
	}
	if (key == 'C') {
	    for (i = 0; i < count; i++) {
		sub = chow;
		while (sub) {
		    pos = pid_pos(list[i].proc->pid, sub->pidlist, sub->count);
		    sub->pidlist[pos].is_selected = 0;
		    sub = sub->mother;
		}
	    }
	    tmp = 0;
	}
	if (key == 'R') {
	    for (i = 0; i < count; i++) {
	        int tmp;
	        sub = chow;
		while (sub) {
		    pos = pid_pos(list[i].proc->pid, sub->pidlist, sub->count);
		    tmp = sub->pidlist[pos].is_selected;
		    sub->pidlist[pos].is_selected = !tmp;
		    sub = sub->mother;
		}
	    }
	    tmp = 0;
	}
	if (key == 'q')
	    tmp = -1;

	if (key == 'r') {
	    if (chow->monitoring)
		tmp = -7;
	    else
		tmp = -2;
	}
	if (key == KEY_LEFT) {
	    /*  e_view = 0; */
	    tmp = -5;
	}
	/*  if(key == 'R') */
	/*      tmp = -5; */

	if (key == 't') {
	    sig = (sig + 1) % NRSIGS;
	}
	if (key == 'm') {
	    selected = 0;
	    selected_row = 0;
	    tmp = -6;
	}
	/* if(tmp == -2) { */
	/*       selected = 0; */
	/*       selected_row = 0; */
	/*     } */
	return tmp;
    } else {
	key = getch();
	key = ' ';
	clear_all_screen();
	draw_top(tag);
	attrset(COLOR_PAIR(1));
	mvprintw(0, COLS - 8, "%s", sigstr);
	refresh();
	return 0;
    }
}


void draw_menu(killer_t *chow, int current_highlight, unsigned int selected, int count, int t_view)
{
    int current_row = 0;
    int i;
    int pos;
    int col = START_COL;
    char *blank;
    int row;
    char *str_buf;
    procinfo_t *options;
    int is_selected;

    if (t_view)
	options = chow->trunk;
    else
	options = chow->pidlist;

    str_buf = (char *) malloc((COLS + 1) * sizeof(char));
    /*  setpwent(); */
    /* printf("in draw menu\n"); */

    blank = (char *) malloc((COLS + 1) * sizeof(char));
    for (i = 0; i < COLS; i++)
	blank[i] = ' ';
    blank[COLS] = '\0';

    for (i = 0; i <= MAX_ROW; i++) {
	row_clear(i);
    }

    if (count) {
	while (current_row < MAX_ROW) {

	    row = START_ROW + ROW_SPACE + current_row;
	    pos = (selected + current_row - current_highlight);
	    row_clear(current_row);

	    if (current_row < count) {
		is_selected = options[pos].is_selected;

		if (is_selected) {
		    attrset(COLOR_PAIR(3) | A_BOLD);
		} else
		    attrset(0);

		if (current_row == current_highlight) {
		    strncpy(str_buf, chow->pidlist[pid_pos(options[pos].proc->pid, chow->pidlist, chow->count)].pname, COLS);

		    if (is_selected)
			attrset(COLOR_PAIR(4) | A_BOLD);
		    else
			attrset(COLOR_PAIR(7) | A_BOLD);
		}
		mvprintw(row, 0, "%s", blank);
		col = START_COL;
		mvprintw(row, col, "%s", options[pos].proc->suser);
		col += USER;
		mvprintw(row, col, "%s", options[pos].ttyc);
		col += TTY_WIDTH;
		mvprintw(row, col, "%i", options[pos].proc->pid);
		col += PID;
		mvprintw(row, col, "%2u.%u", options[pos].proc->pcpu / 10, options[pos].proc->pcpu % 10);
		col += CPU;
		mvprintw(row, col, "%2ld.%ld", options[pos].pmem / 10, options[pos].pmem % 10);
		col += MEM;
		mvprintw(row, col, "%2ld", options[pos].proc->nice);
		col += NICE;
		mvprintw(row, col, "%s", options[pos].s_pname);
	    }
	    current_row++;
	}
    }				/*  else */
    /*        for(i = 0; i <= MAX_ROW; i++) { */
    /*        row_clear(i); */
    /*        } */
    if (count) {
	attrset(COLOR_PAIR(4) | A_BOLD);
	mvprintw(LINES - 1, 0, "%s", blank);
	mvprintw(LINES - 1, 0, "%s", str_buf);
    }
    refresh();
    free(blank);
}


void clear_all_screen()
{
    clear();
    refresh();
}


void move_up(int times, int *selected_row, unsigned int *selected)
{
    int i;
    for (i = 0; i < times; i++) {

	if (*selected_row > 0) {
	    (*selected_row)--;
	}
	if (*selected > 0) {
	    (*selected)--;
	}
    }
}


void move_down(int times, int *selected_row, unsigned int *selected, int count)
{
    int i;
    if (count) {
	for (i = 0; i < times; i++) {
	    if (*selected < count - 1)
		(*selected)++;

	    if (*selected_row < (MAX_ROW - 1) && *selected_row < count - 1) {
		(*selected_row)++;
	    }
	}
    }
}


void row_clear(int current_row)
{
    int i;
    char *tmp;

    tmp = (char *) malloc((COLS + 1) * sizeof(char));

    attrset(0);

    for (i = 0; i < COLS; i++) {
	tmp[i] = ' ';
    }

    tmp[COLS] = '\0';

    mvprintw(START_ROW + ROW_SPACE + current_row, 0, "%s", tmp);
    free(tmp);
}


void draw_top(int key)
{
    int col = START_COL;
    char *tmp;
    int size;
    int i;
    int space;
    int selected = 1;
    int unselected = 4;
    static int key_buf;

    if (key == -1)
	key = key_buf;
    else
	key_buf = key;

    size = sizeof(char);

    space = USER;
    if (key == KEY_F(1) || key == '1' || key == 0)
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    tmp = (char *) malloc((space + START_COL) * size);
    for (i = 0; i < space + START_COL - 1; i++)
	tmp[i] = ' ';

    tmp[i] = '\0';

    mvprintw(START_ROW, 1, tmp);
    mvprintw(START_ROW, col, "user");

    col += space;
    space = TTY_WIDTH;
    if (key == KEY_F(2) || key == '2')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';
    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "tty");

    col += space;
    space = PID;
    if (key == KEY_F(3) || key == '3')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';
    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "PID");

    col += space;
    space = CPU;
    if (key == KEY_F(4) || key == '4')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';
    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "%cCPU", '%');

    col += space;
    space = MEM;
    if (key == KEY_F(5) || key == '5')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';

    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "%MEM");
/*----------------------------------------*/
    col += space;
    space = NICE;
    if (key == KEY_F(6) || key == '6')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';

    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "nice");
/*----------------------------------------*/
    col += space;
    space = COLS - col;
    if (key == KEY_F(7) || key == '7')
	attrset(COLOR_PAIR(selected) | A_BOLD);
    else
	attrset(COLOR_PAIR(unselected) | A_BOLD);
    free(tmp);
    tmp = (char *) malloc(space * size);
    for (i = 0; i < space - 1; i++)
	tmp[i] = ' ';

    tmp[i] = '\0';
    mvprintw(START_ROW, col + 1, tmp);
    mvprintw(START_ROW, col, "command");
    free(tmp);
}


void help_screen(void)
{
    int line;

    clear_all_screen();

    attrset(0);
    /*  attrset(COLOR_PAIR(1)); */
    for (line = 0; help_txt[line]; line++) {
	mvprintw(line+2, 4, "%s", help_txt[line]);
    }
}


void input_dlg(char *input, char *greet)
{
    WINDOW *dialogue;
    int i, check, pos, length, j;
    char blank[COLS];

    int tmp;
    int field = 0;
    int init_pos = strlen(greet) + 1;

    for (i = 0; i < COLS - 1; i++)
	blank[i] = ' ';

    blank[i] = '\0';

    dialogue = newwin(1, COLS, LINES - 1, 0);

    wbkgd(dialogue, COLOR_PAIR(0));

    /*wattrset(dialogue, COLOR_PAIR(4));
    box(dialogue, ' ', ' ');
    */
    wattrset(dialogue, COLOR_PAIR(0));

    mvwprintw(dialogue, 0, 0, "%s", greet);
    /*wattrset(dialogue, COLOR_PAIR(0));
    mvwprintw(dialogue, 3, BOX_WIDTH - 10, "%s", "[cancel]");
*/
    noecho();
    curs_set(1);
    refresh();

    wrefresh(dialogue);
    /*  mvwgetstr(dialogue, 1, 0, input); */
    /*  wscanw(dialogue, "which da fuck one? %s", &input); */

    length = strlen(input);;
    i = 0;
    check = 1;
    pos = init_pos;

    while (check) {
	mvwprintw(dialogue, 0, 0, "%s", greet);
	if (field == 0) {
	    input[length] = '\0';
	    wattrset(dialogue, COLOR_PAIR(0));
	    mvwprintw(dialogue, 0, init_pos, "%s", blank);
	    mvwprintw(dialogue, 0, init_pos, "%s", input);
	    /*wattrset(dialogue, COLOR_PAIR(4));
	      box(dialogue, ' ', ' ');
	      wattrset(dialogue, COLOR_PAIR(0));
	    
	      mvwprintw(dialogue, 3, BOX_WIDTH - 10, "%s", "[cancel]");
	    */
	    wmove(dialogue, 0, pos);
	    wrefresh(dialogue);
	    /*  mvwprintw(dialogue, 3, pos, "%s", "    "); */
	    /*  tmp = mvwgetch(dialogue, 2, pos); */
	    tmp = getch();
	    if (tmp != '\t') {
		if (tmp != '\n') {
		    if (tmp == KEY_BACKSPACE) {
			if (pos > init_pos) {
			    for (j = i; j < length; j++) {
				input[j - 1] = input[j];
			    }
			    pos--;
			    i--;
			    length--;
			}
		    } else if (tmp == KEY_LEFT) {
			if (i > 0) {
			    pos--;
			    i--;
			}
		    } else if (tmp == KEY_RIGHT) {
			if (i < length) {
			    pos++;
			    i++;
			}
		    } else if (tmp == ' ') {
			if (length < BOX_WIDTH - 5) {
			    for (j = length; j > i; j--) {
				input[j] = input[j - 1];
			    }
			    input[i] = ' ';
			    pos++;
			    length++;
			    i++;
			}
		    } else if (tmp == KEY_DC) {
			if (i < length) {
			    for (j = i; j < length; j++) {
				input[j] = input[j + 1];
			    }
			    length--;
			}
		    } else {
			if (length < BOX_WIDTH - 5) {
			    for (j = length; j > i; j--) {
				input[j] = input[j - 1];
			    }
			    input[i] = tmp;
			    pos++;
			    length++;
			    i++;
			}
		    }
		} else
		    check = 0;
	    } else {
		field = (field + 1) % 2;
	    }
	} else {
	    /*  mvwprintw(dialogue, 3, pos, "%s", "    "); */
	  input[0] = '\0';
	  check = 0;
	}
    }

    input[length] = '\0';
    /*wattrset(dialogue, COLOR_PAIR(4));
      box(dialogue, ' ', ' ');
*/    
    wattrset(dialogue, COLOR_PAIR(0));
    /*  mvwprintw(dialogue, 5, 2, "%s", input); */
    wrefresh(dialogue);
    noecho();
    curs_set(0);
    /*  tmp = mvwgetch(dialogue, 5, 2); */
    delwin(dialogue);
    refresh();
}


void murder(int selected, procinfo_t * list, int count, int sig)
{
    int i;
    int group = 0;

    for (i=0; i<count; ++i) {
	if (list[i].is_selected) {
	    if (kill(list[i].proc->pid, sig) == -1) {
	      /* XXX we should do something about... */
	    };
	    group = 1;
	}
    }

    if (!group)
	kill(list[selected].proc->pid, sig);
	
    sleep(1);
}



void find(killer_t *chow, char *input, unsigned int *selected, int *selected_row, int t_view) {
    
    regex_t preg;
    int tmp = *selected + 1;
    int check = 1;

    procinfo_t *list;

    if(t_view)
	list = chow->trunk;
    else
	list = chow->pidlist;
    
    if (regcomp(&preg, input, REG_ICASE | REG_NOSUB | REG_EXTENDED) != 0)
	return;

    while(tmp < chow->count && check) {
	if (regexec(&preg, list[tmp].pname, 0, NULL, 0) != 0)
	    tmp++;
	else 
	    check = 0;
    }
    
    if (!check) {
	for(; *selected < tmp; ) {
	    move_down(1, selected_row, selected, chow->count);
	}
    }

}
