#include "base.h"
#include "tree.h"

void graph_branch(tree *branch, killer_t *chow, int t_col) {
  /* static int t_row = 0; */
    int i, j;
    char *tmp;
    int pos;
    int t_row;
    int expand;

    procinfo_t *pidlist = chow->pidlist;
    procinfo_t *trunk = chow->trunk;
    
    
    t_col += 2;
    for(i = 0; i < branch->num_child; i++) {
	/* printf("for loop\n"); */
	(chow->t_count)++;
	/*  mvprintw(0, 10, "%i  ", chow->t_count ); */
	t_row = chow->t_count;
	
	pos = pid_pos(branch->children[i]->pid, pidlist, chow->count);	

	pidlist[pos].num_child = branch->children[i]->num_child;

	branch->row = t_row;
	branch->col = t_col;

	
	tmp = (char *) malloc (t_col * sizeof(char) + 256);

	for(j = 0; j < t_col - 2; j++) {
	  tmp[j] = ' ';
	}

	if(pidlist[pos].num_child && pidlist[pos].expand == 0)
	  tmp[j++] = '+';
	else if (pidlist[pos].num_child && pidlist[pos].expand == 1)
	  tmp[j++] = '@';
	else if (!pidlist[pos].num_child)
	  tmp[j++] = '`';
	tmp[j++] = '-';
	tmp[j] = '\0';

	/* printf("tmp\n"); */

	
	
	
	/*  printf("before strcat\n"); */
	if(branch->children[i]->num_child)
	    strcat(tmp, "+");
		
	
	dup_procinfo_t(&(trunk[t_row - 1]), &(pidlist[pos]));
	
	strcat(tmp, pidlist[pos].proc->cmd);		

	/*  trunk[t_row - 1].s_pname = (char *) realloc(trunk[t_row - 1].pname, (strlen(tmp) + 1) * sizeof(char)); */
	trunk[t_row - 1].s_pname = strdup(tmp);
	
	free(tmp);		

       	
	trunk[t_row - 1].num_child = branch->children[i]->num_child;
	
	/* mvprintw(t_row, t_col, "%s", pidlist[pid_pos(branch->children[i]->pid, pidlist)].s_pname); */
	/* printf("recursive step\n"); */
	pos = pid_pos(branch->children[i]->pid, chow->pidlist, chow->count); 
	expand = chow->pidlist[pos].expand;
	if(expand) {
	  graph_branch(branch->children[i], chow, t_col);
	}
      }
}


void make_tree(killer_t *chow) {

  
    chow->ptree = (tree *) malloc(sizeof(tree));
    
    chow->ptree->pid = -1;
    chow->ptree->parent = NULL;    
    /*  printf("make branch\n"); */
    make_branch(chow->pidlist, chow->ptree, chow->count);

}

void make_branch(procinfo_t *pidlist, tree *branch, int count) {

    int j;

    find_children(branch, pidlist, count);

    for(j = 0; j < branch->num_child; j++) {
	branch->children[j]->parent = branch;
	/* printf("going into recursive step\n"); */
	make_branch(pidlist, branch->children[j], count);
    }
}



pid_t find_parent(pid_t pid, procinfo_t *pidlist, int count) {

    return pidlist[pid_pos(pid, pidlist, count)].proc->ppid;

}

void find_children(tree *branch, procinfo_t *pidlist, int count) {

    int i, j;

    /* printf("branch->pid = %i\n", branch->pid); */
    branch->num_child = 0;

    if(branch->pid != -1) {
	for(i = 0; i < count; i++) {
	    if(pidlist[i].proc->ppid == branch->pid)
		(branch->num_child)++;
	}
    }else 
	for(i = 0; i < count; i++) {
	    if(pid_pos(pidlist[i].proc->ppid, pidlist, count) == -1)
		(branch->num_child)++;
	}

    /* printf("num_child = %i\n", branch->num_child); */

    branch->children = (tree **) calloc(branch->num_child, sizeof(tree));
    for(i = 0; i < branch->num_child; i++) {
	branch->children[i] = (tree *) malloc(sizeof(tree));
    }

    i = 0;
    j = 0;

    if(branch->pid != -1) {
	while(j < branch->num_child && i < count) {
	    if(pidlist[i].proc->ppid == branch->pid)
		branch->children[j++]->pid = pidlist[i].proc->pid;
	    i++;
	}
    }else
	while(j < branch->num_child && i < count) {
	    if(pid_pos(pidlist[i].proc->ppid, pidlist, count) == -1)
		branch->children[j++]->pid = pidlist[i].proc->pid;
	    i++;
	}
}

void free_branch(tree *branch) {
    int i;

    for(i = 0; i < branch->num_child; i++) {
	free_branch(branch->children[i]);
    }

    free(branch->children);
    free(branch);

}

void draw_strings(procinfo_t *trunk, int count) {

    int i, j, k;

    for(i = 0; i < count; i++) {
	j = 0;
	while(trunk[i].s_pname[j] == ' ') {
	    j++;
	}
	k = i - 1;
	while(k >= 0 && (trunk[k].s_pname[j] == ' ' || trunk[k].s_pname[j] == '`')) {
	  /*  if(trunk[k].num_child && trunk[k].pname[j] == '`' && trunk[k].expand == 0) */
/*  	    trunk[k].pname[j] = '+'; */
/*  	  else if(trunk[k].expand == 1 && trunk[k].pname[j] == '`') */
/*  	    trunk[k].pname[j] = '@'; */
/*  	  else */
	    trunk[k].s_pname[j] = '|';
	  k--;
	}
    }
    
   /*   j = 0; */
/*      while(trunk[count - 1].pname[j] == ' ') { */
/*        j++; */
/*      } */
/*      k = count - 1; */
    
/*      if(trunk[k].num_child && trunk[k].pname[j] == '`' && trunk[k].expand == 0) */
/*        trunk[k].pname[j] = '+'; */
/*      else if(trunk[k].expand == 1 && trunk[k].pname[j] == '`') */
/*        trunk[k].pname[j] = '@'; */
/*      else if(trunk[k].num_child == 0) */
/*        trunk[k].pname[j] = '`'; */

}

int pid_pos(pid_t pid, procinfo_t *pidlist, int count) {

    int i;
    int check;

    check = 1;
    i = 0;

    while(check && i < count) {	
	if (pidlist[i].proc->pid == pid)
	    check = 0;
	else
	    i++;
    }

    if(i < count)
	return i;
    else
	return -1;

}

void shell_sort(procinfo_t *pidlist, int tag, int count) {

    int gap;
    int i;
    int swap;
    long diff;
    procinfo_t temp;
    static int key_buf = 0;
    static int key_comp = 0;

    temp.proc = NULL;
    
    if(tag != -1) {
	if(key_buf == tag)
	    key_comp = (key_comp + 1) % 2;
    } else
	tag = key_buf;

    if(count % 2)
	gap = (count + 1) / 2;
    else
	gap = count / 2;


    while (gap > 0) {
	swap = 1;
	while(swap == 1) {
	    swap = 0;
	    for(i = 0; i < count - gap; i++) {
		if(tag == KEY_F(1) || tag == '1')
		    diff = pidlist[i].proc->suid - pidlist[i + gap].proc->suid;
		else if (tag == KEY_F(2) || tag == '2')
		    diff = alpha(pidlist[i].ttyc, pidlist[i + gap].ttyc);
		else if(tag == KEY_F(3) || tag == '3')
		    diff = pidlist[i].proc->pid - pidlist[i + gap].proc->pid;
		else if (tag == KEY_F(4) || tag == '4')
		    diff = (long) pidlist[i].proc->pcpu - (long) pidlist[i + gap].proc->pcpu;
		else if (tag == KEY_F(5) || tag == '5')
		    diff = pidlist[i].pmem - pidlist[i + gap].pmem;
		else if (tag == KEY_F(6) || tag == '6')
		  diff = pidlist[i].proc->nice - pidlist[i + gap].proc->nice;
		else if (tag == KEY_F(7) || tag == '7')
		  diff = alpha(pidlist[i].pname, pidlist[i + gap].pname);
		else
		    diff = 0;

		diff *= pow(-1, key_comp);

		if (diff < 0) {
		    temp = pidlist[i];
		    pidlist[i] = pidlist[i + gap];
		    pidlist[i + gap] = temp;
		    swap = 1;
		}

	    }
	}
	if(gap % 2 && gap != 1)
	    gap = (gap + 1) / 2;
	else
	    gap = gap / 2;
    }

    key_buf = tag;

}



int alpha(char *string1, char *string2) {

    int i = 0;
    int check = 1;
    int diff;

    while(string1[i] != '\0' && string2[i] != '\0' && check) {

	if(string1[i] != string2[i]) {
	    check = 0;
	    diff = string2[i] - string1[i];
	} else
	    i++;

    }

    return diff;

}

void dup_procinfo_t(procinfo_t *target, procinfo_t *orig) {
    
    memcpy(target, orig, sizeof(procinfo_t));
    target->pname = NULL;
    target->s_pname = NULL;
        
    target->proc = (proc_t *) malloc(sizeof(proc_t));
    memset(target->proc, '#', sizeof(proc_t));
    memcpy(target->proc, orig->proc, sizeof(proc_t));
    target->pname = strdup(orig->pname);
    /*  target->s_pname = strdup(orig->s_pname); */
    strcpy(target->proc->suser, orig->proc->suser);
    
    strcpy(target->proc->cmd, orig->proc->cmd);
    strcpy(target->ttyc, orig->ttyc);
    target->proc->environ = NULL;
    target->proc->cmdline = NULL;

}

void free_list(procinfo_t *pidlist, int count) {

    int i;
    
    for(i = 0; i < count; i++) {
	freeproc(pidlist[i].proc);
	if(pidlist[i].pname)
	    free(pidlist[i].pname);
	  	
	if(pidlist[i].s_pname)
	  free(pidlist[i].s_pname);
    }
    
    free(pidlist);
}
